Subject: Building tvix on openSUSE: missing README in tvix/vendor/tower-otel-http-metrics-0.11.0/src/../

From: Johannes Kastl <[email-masked]>
Date: Sat, 22 Mar 2025 09:40:34 +0100

Dear tvix maintainers,

out of curiosity I tried to create a package for tvix for openSUSE. I
found no tags or versions, so I used the latest commit and went from
there.

I got a package that starts building, but am now stuck with the
following error:

> [  348s]    Compiling tower-otel-http-metrics v0.11.0
> [  348s] error: couldn't read `/home/abuild/rpmbuild/BUILD/tvix-0.0.1_1742309285.9898a758b-build/tvix-0.0.1~1742309285.9898a758b/tvix/vendor/tower-otel-http-metrics-0.11.0/src/../README.md`: No such file or directory (os error 2)
> [  348s]  --> /home/abuild/rpmbuild/BUILD/tvix-0.0.1_1742309285.9898a758b-build/tvix-0.0.1~1742309285.9898a758b/tvix/vendor/tower-otel-http-metrics-0.11.0/src/lib.rs:1:10
> [  348s]   |
> [  348s] 1 | #![doc = include_str!("../README.md")]
> [  348s]   |          ^^^^^^^^^^^^^^^^^^^^^^^^^^^^
> [  348s]   |

As I am not using nix for the build and the build has to happen
completely offline, I have prepared all rust dependencies upfront (as
is usual for rust packages on openSUSE). There is a directory for
tower-otel-http-metrics-0.11.0 in the vendor tarball (which is
extracted into the tvix subfolder), but it does not contain a README:

> $ tar tvf vendor.tar.zst |grep tower-otel
> -rw-r--r-- 0/0             328 1970-01-01 00:00 vendor/tower-otel-http-metrics-0.11.0/.cargo-checksum.json
> -rw-r--r-- 0/0            9954 1970-01-01 00:00 vendor/tower-otel-http-metrics-0.11.0/Cargo.lock
> -rw-r--r-- 0/0            1763 1970-01-01 00:00 vendor/tower-otel-http-metrics-0.11.0/Cargo.toml
> -rw-r--r-- 0/0           10707 1970-01-01 00:00 vendor/tower-otel-http-metrics-0.11.0/src/lib.rs

Is this a known issue? Am I missing some flags for "cargo build"?

Kind Regards,
Johannes